var juniframe = function() {
    return {
        make: function(config) {
            let title = ''; // 标题
            let body = ''; // 内容
            let backgroundColor = '#999'; // 遮罩颜色
            let opacity = '0.1'; // 遮罩不透明度
            let confirmBtn = '确认'; // 点击确认按钮名称
            let confirm = ''; // 点击确认回调
            let cancelBtn = '取消'; // 点击取消按钮名称
            let cancel = ''; // 点击取消回调
            let width = ''; // 宽度
            let height = ''; // 高度
            let footer = true; // 是否显示操作按钮
            
            if (config.title != undefined) title = config.title;
            if (config.body != undefined) body = config.body;
            if (config.backgroundColor != undefined) backgroundColor = config.backgroundColor;
            if (config.opacity != undefined) opacity = config.opacity;
            if (config.confirmBtn != undefined) confirmBtn = config.confirmBtn;
            if (config.confirm != undefined) confirm = config.confirm;
            if (config.cancelBtn != undefined) cancelBtn = config.cancelBtn;
            if (config.cancel != undefined) cancel = config.cancel;
            if (config.width != undefined) width = config.width;
            if (config.height != undefined) height = config.height;
            if (config.footer != undefined) footer = config.footer;

            let bodyHeight = '';
            if (footer != true) {
                bodyHeight = 'style="height: calc(100% - 50px);"';
            }

            let str = `<div class="jun_iframe"></div>
                        <div class="jun_iframe">
                            <div class="jun_iframe_zhe" style="background-color:`+backgroundColor+`;opacity:`+opacity+`"></div>
                            <div class="jun_iframe_main">
                                <div class="jun_iframe_body" style="width:`+width+`;height: `+height+`;">
                                    <div class="jun_iframe_title">
                                        <div>`+title+`</div>
                                        <div class="jun_iframe_close"></div>
                                    </div>
                    
                                    <div class="jun_iframe_content" `+bodyHeight+`>`;
            if (this.isURLorPath(body) === true) {
                str += `<iframe src="`+body+`" style="width: 100%;border: 0px;height: 100%;"></iframe>`;
            } else {
                str += body;
            }
            str += `</div>`;
             
            if (footer == true) {
                str += `<div class="jun_iframe_footer">
                            <div class="jun_iframe_button is-sm" id="jun_iframe_cancel">`+cancelBtn+`</div>
                            <div class="jun_iframe_button jun_iframe_button_primary is-sm" id="jun_iframe_confirm">`+confirmBtn+`</div>
                        </div>`;
            }
            str += `</div>
                    </div>
                </div>`;                        
            document.body.innerHTML += str;

            var _iframeThis = this;
            if (confirm) {
                let cancelElement = document.getElementById('jun_iframe_confirm');
                cancelElement.addEventListener('click', confirm);
            }

            let cancelElement = document.getElementById('jun_iframe_cancel');
            if (cancel) {
                cancelElement.addEventListener('click', cancel);
            }
            cancelElement.addEventListener('click', function(){
                _iframeThis.close();
            });

            let closeElement = document.getElementsByClassName('jun_iframe_close')[0];
            
            closeElement.addEventListener('click', function(){
                _iframeThis.close();
            });
        },
        close: function(){
            var divsToRemove = document.querySelectorAll('div.jun_iframe');
            divsToRemove.forEach(function(div) {
                div.parentNode.removeChild(div);
            });
        },
        isURLorPath:function (url) {
            const regex = /^(?:(?:[a-z]+:\/\/)?[^\s\/$.?#].[^\s]*)$/;  
         
            if (/\.html$/.test(url) && !/^(?:[a-z]+:\/\/)?[^\s\/$.?#].[^\s]*$/.test(url.split('.html')[0])) {  
                return false;  
            }  
        
            return regex.test(url);  
        }
    }
}(); 